/* 
 This file was generated by Dashcode.  
 You may edit this file to customize your widget or web page 
 according to the license.txt file included in the project.
 */

// Properties set by attributes panel
var updateInterval;

// Monitor objects (see CommandMonitor.js)
var mouseMonitor;
var keyboardMonitor;
var trackpadMonitor;
var monitorsRunning;
var mouseString;
var mouseClass;
var mouseBattClass;
var keyboardString;
var keyboardClass;
var keyboardBattClass;
var trackpadString;
var trackpadClass;
var trackpadBattClass;
var localtest=0;
var req;
var plistReq;
var currentVersion;
var updateAvailable;
var fadeTimer;
var updateShown;
var updateURL;

//
// Function: initMonitor()
// Called by load() when widget starts up to set up and start the monitors
//
function startMonitors()
{
    // Set initial values
    setMouseValue();
    setKeyboardValue();
    setTrackpadValue();
    
    // Set up the monitors
    mouseMonitor = setInterval(setMouseValue,updateInterval);
    keyboardMonitor = setInterval(setKeyboardValue,updateInterval);
    trackpadMonitor = setInterval(setTrackpadValue,updateInterval);
    
    //testMonitor = setInterval(function () { alert("testMonitor"); },1000);
        
    monitorsRunning = true;
}

function stopMonitors()
{
    clearInterval(mouseMonitor);
    clearInterval(keyboardMonitor);
    clearInterval(trackpadMonitor);
    
    monitorsRunning = false;
}

function setMouseValue() 
{
        value = MightyMonitor.getDeviceData(mouseString,mouseClass,mouseBattClass);
        //value=74;
        if (value>100) value=100;
        setGaugeValue("gauge-mouse", value);
        setButtonValue("indicator-mouse", value);
        //alert(value);
}

function setKeyboardValue() 
{
        value = MightyMonitor.getDeviceData(keyboardString,keyboardClass,keyboardBattClass);
        //value=14;
        if (value>100) value=100;
        setGaugeValue("gauge-keyboard", value);
        setButtonValue("indicator-keyboard", value);
        //alert(value);
}

function setTrackpadValue() 
{
        value = MightyMonitor.getDeviceData(trackpadString,trackpadClass,trackpadBattClass);
        //value=104;
        if (value>100) value=100;
        setGaugeValue("gauge-trackpad", value);
        setButtonValue("indicator-trackpad", value);
        //alert(value);
}

//
// Function: setElementText(elementName, elementValue)
// Set the text contents of an HTML div
//
// elementName: Name of the element in the DOM
// elementValue: Text to display in the element
//
function setElementText(elementName, elementValue)
{
    var element = document.getElementById(elementName);
    if (element) {
        element.innerText = elementValue;
    }
}

//
// Function: setLocaleStrings()
// Set the text of various dropdown options based on Locale
//
function setLocaleStrings ()
{
    var mydisplay = document.getElementById("displaypop");
    var mykey = document.getElementById("keypop");
    var mytrack = document.getElementById("trackpop");
    var mymouse = document.getElementById("mousepop");
	var mouseLabel = document.getElementById("label-mouse");
	var keyLabel = document.getElementById("label-keyboard");
	var trackpadLabel = document.getElementById("label-trackpad");
	var mouseLabel1 = document.getElementById("label-mouse1");
	var keyLabel1 = document.getElementById("label-keyboard1");
	var trackpadLabel1 = document.getElementById("label-trackpad1");
	var trackpadLabeld = document.getElementById("label-trackpad-drop");
    var widgetLabel = document.getElementById("label-about");
                
    // Change Gauge and Battery in displaypop
    mydisplay.options[0].text = dashcode.getLocalizedString("Gauge"); // Gauge
    mydisplay.options[1].text = dashcode.getLocalizedString("Battery"); // Battery
    mydisplay.options[2].text = dashcode.getLocalizedString("Battery") + "+"; // Battery + Digits
    
    // Change the word "None" in the mouse, trackpad, and keyboard dropdowns
    mykey.options[mykey.options.length-1].text = dashcode.getLocalizedString("None-keyboard");
    mytrack.options[mytrack.options.length-1].text = dashcode.getLocalizedString("None-trackpad");
    mymouse.options[mymouse.options.length-1].text = dashcode.getLocalizedString("None-mouse");
    
    // Update the word for "battery" in the keyboard dropdown
    for (var i=0; i<mykey.options.length-1; i++) {
        if (mykey.options[i].text.search(/batteries/)>0) {
            mykey.options[i].text = mykey.options[i].text.replace("batteries",dashcode.getLocalizedString("batteries"));
        }
    }

    // shrink size of widget labels if in Japanese
    if (dashcode.getLocalizedString("Battery") == "電池") { 
        mouseLabel.style.fontSize = "9px";
        keyLabel.style.fontSize = "9px";
        trackpadLabel.style.fontSize = "9px";
        mouseLabel1.style.fontSize = "9px";
        keyLabel1.style.fontSize = "9px";
        trackpadLabel1.style.fontSize = "9px";
        trackpadLabeld.style.fontSize = "11px";
        widgetLabel.style.fontSize = "12px";
        for (i=0; i<mykey.options.length-1; i++) {
            if (mykey.options[i].text.search(/Brushed/)>0) {
                mykey.options[i].text = mykey.options[i].text.replace("Brushed","アルミニウム");
            }
        }
    } else if (dashcode.getLocalizedString("Battery") == "Батарея") { 
        for (i=0; i<mykey.options.length-1; i++) {
            if (mykey.options[i].text.search(/Brushed/)>0) {
                mykey.options[i].text = mykey.options[i].text.replace("Apple Brushed","Алюминиевая Apple");
            }
        }
    }


}

//
// Function: clearDispaly()
// After changing preferences, this sets the value of the gauges to 0 to clear out any old values
//
//
function clearDisplay ()
{
    setButtonValue("indicator-keyboard",0);
    setButtonValue("indicator-trackpad",0);
    setButtonValue("indicator-mouse",0);
    setGaugeValue("gauge-keyboard",0);
    setGaugeValue("gauge-trackpad",0);
    setGaugeValue("gauge-mouse",0);
}

//
// Function: setGaugeValue(gaugeId, value)
// Sets the value of one of the monitor gauges
//
// gaugeId: Gauge to set
// value: Value to set gauge to
//
function setGaugeValue (gaugeId, value)
{
    var element = document.getElementById(gaugeId);
    if (element != null && element.object != null && element.object.setValue != null) {
        element.object.setValue(value);
    }
}

//
// Function: setButtonValue(buttonId, value)
// Sets the value of one of the monitor gauges
//
// buttonId: Button to set
// value: Value to set button to (changes background color based on battery percent)
//
function setButtonValue (buttonId, value)
{    
    var displayPercent=0;
    var displayIndex = widget.preferenceForKey("johnstarmerMMdisplay31");
    var element = document.getElementById(buttonId);
    var elementPercent = document.getElementById(buttonId + "Percent");
    var batHeight = Math.round(0.6*value);
    var heightStr = batHeight + "px";
    var hiTop = 98 - batHeight + "px";
    var lowTop = 81 - batHeight + "px";
        
    if (displayIndex === undefined) { displayIndex = 0; }
    if (displayIndex == 2) { displayPercent = 1; } // Battery+

    if (element != null && element.object != null && element.object.setValue != null) {
        element.object.setValue(value);
        element.style.clip = "rect(0px,36px," + heightStr + ",0px)";
        element.style.top = hiTop;
        elementPercent.style.display = "none";
    }
    
    if (displayIndex && value < 71) { // display numeric values in addition to the battery level indicator
        elementPercent.style.top = lowTop;
        elementPercent.style.display = "block";
        setElementText(buttonId + "Percent", value + "%");
    } else if (displayPercent && displayIndex && value > 70) { // display numeric values in addition to the battery level indicator
        elementPercent.style.top = hiTop;
        elementPercent.style.display = "block";
        setElementText(buttonId + "Percent", value + "%");
    }
}

function initSliders()
{
    var wslider = document.getElementById("warning-slider");
    var cslider = document.getElementById("critical-slider");
    var wbatt = document.getElementById("warning");
    var cbatt = document.getElementById("critical");
    var warningValue = widget.preferenceForKey("johnstarmerMMwslider31");
    var criticalValue = widget.preferenceForKey("johnstarmerMMcslider31");
    
    if (warningValue === undefined) { warningValue=25; }
    if (criticalValue === undefined) { criticalValue=10; }
    
    var value = warningValue;
    wslider.value = value;
    updateBatt(value,true);
    
    value = criticalValue;
    cslider.value = value;
    updateBatt(value,false);
}


function initLabelPrefs()
{
    var mouseBox = document.getElementById("mouseText");
    var keyBox = document.getElementById("keyText");
    var trackBox = document.getElementById("trackText");
    var mouseText = widget.preferenceForKey("johnstarmerMMmouseText31");
    var keyText = widget.preferenceForKey("johnstarmerMMkeyText31");
    var trackText = widget.preferenceForKey("johnstarmerMMtrackText31");
    
    if (mouseText === undefined) { mouseText = dashcode.getLocalizedString("Mouse"); }
    if (keyText === undefined) { keyText = dashcode.getLocalizedString("Keyboard"); }
    if (trackText === undefined) { trackText = dashcode.getLocalizedString("Trackpad"); }
    mouseBox.value = mouseText;
    keyBox.value = keyText;
    trackBox.value = trackText;
    
    updateLabelTemp();
}

function warningUp(event)
{
    var wslider = document.getElementById("warning-slider");
    var cslider = document.getElementById("critical-slider");
    var value = parseInt(wslider.value) + 1;
    
    wslider.value = value;
    updateBatt(value,true);
    
    if ((value - cslider.value)<6) {
        cslider.value = value-5;
        updateBatt(value-5,false);
    }
}

function warningDown(event)
{
    var wslider = document.getElementById("warning-slider");
    var cslider = document.getElementById("critical-slider");
    var value = parseInt(wslider.value) - 1;
    
    wslider.value = value;
    updateBatt(value,true);
    
    if ((value - cslider.value)<6) {
        cslider.value = value-5;
        updateBatt(value-5,false);
    }
}

function criticalUp(event)
{
    var wslider = document.getElementById("warning-slider");
    var cslider = document.getElementById("critical-slider");
    var value = parseInt(cslider.value) + 1;
    
    cslider.value = value;
    updateBatt(value,false);
    
    if ((wslider.value - value)<5) {
        wslider.value = value+5;
        updateBatt(value+5,true);
    }
}

function criticalDown(event)
{
    var wslider = document.getElementById("warning-slider");
    var cslider = document.getElementById("critical-slider");
    var value = parseInt(cslider.value) - 1;
    
    cslider.value = value;
    updateBatt(value,false);
    
    if ((wslider.value - value)<5) {
        wslider.value = value+5;
        updateBatt(value+5,true);
    }
}

function warningChange(value)
{
    // Insert Code Here
    var buttonId = "warning"
    var wslider = document.getElementById(buttonId + "-slider");
    var cslider = document.getElementById("critical-slider");
    var value = parseInt(wslider.value);
    
    updateBatt(value,true);
    if ((wslider.value - cslider.value)<6) {
        cslider.value = value-5;
        updateBatt(value-5,false);
    }
}

function criticalChange(value)
{
    // Insert Code Here
    var buttonId = "critical"
    var wslider = document.getElementById("warning-slider");
    var cslider = document.getElementById(buttonId + "-slider");
    var value = parseInt(cslider.value);
    
    updateBatt(value,false);

    if ((wslider.value - cslider.value)<5) {
        wslider.value = value+5;
        updateBatt(value+5,true);
    }
}

function resetPrefs()
{
    clearPrefs();
    initLabelPrefs();
    initSliders();
    updateLabelTemp();
}

function updateLabelTemp()
{
    var mouseText = document.getElementById("mouseText").value;
    var keyText = document.getElementById("keyText").value;
    var trackText = document.getElementById("trackText").value;
    
    setElementText("label-keyboard1",keyText);
    setElementText("label-mouse1",mouseText);
    setElementText("label-trackpad1",trackText);
}

function updateBattTemp (buttonId, value)
{    
    var element = document.getElementById(buttonId);
    var warningValue = parseInt(document.getElementById("warningPercent").innerText);
    var criticalValue = parseInt(document.getElementById("criticalPercent").innerText);
    var batHeight = Math.round(0.6*value);
    var heightStr = batHeight + "px";
    var topStr = 70 - batHeight + "px";

    if (warningValue === undefined) { warningValue=25; }
    if (criticalValue === undefined) { criticalValue=10; }
    element.object.setWarningValue(warningValue);
    element.object.setCriticalValue(criticalValue);
    
    if (element != null && element.object != null && element.object.setValue != null) {
        element.object.setValue(value);
        element.style.clip = "rect(0px,36px," + heightStr + ",0px)";
        element.style.top = topStr;
    }
    
}

function updateBatt(value,warning)
{
    var buttonId;
    
    if (warning) { buttonId="warning"; } else { buttonId="critical"; }
    var element = document.getElementById(buttonId);
    var batHeight = Math.round((0.6*value));
    var heightStr = batHeight + "px";
    var topStr = 219 - batHeight + "px";

    if (warning) {
        element.object.imageOnPath =  "Images/BatteryRoundWarning.png";
        element.object.imageCriticalPath = "Images/BatteryRoundWarning.png";
    } else {
        element.object.imageOnPath =  "Images/BatteryRoundCritical.png";
        element.object.imageWarningPath = "Images/BatteryRoundCritical.png";
    }

    if (element != null && element.object != null && element.object.setValue != null) {
        element.object.setValue(value);
        element.style.clip = "rect(0px,36px," + heightStr + ",0px)";
        element.style.top = topStr;
    }
    
    setElementText(buttonId + "Percent", value + "%");
    updateBattTemp("indicator-keyboard1",60);
    updateBattTemp("indicator-mouse1",80);
    updateBattTemp("indicator-trackpad1",30);
}

//
// Function: load()
// Called by HTML body element's onload event when the widget is ready to start
//
function load()
{
    dashcode.setupParts();

    // set the display options dropdown to the correct options based on the locale
    setLocaleStrings();
	    
    // get last update that was alerted
    updateShown = widget.preferenceForKey("johnstarmerMMupdate31");
    
    // update the preferences for 4.1
    updatePrefs();
    
    // get the current version of MightyMonitor
    getCurrentVersion();
    
    // set the size of the widget and which dials to display
	updateDisplay();
	
    drawCanvas("canvas-back",13,13,294,214,170,true);
    
    // Get the properties
    updateInterval = +attributes.updateInterval;
    if (!updateInterval) {
        updateInterval = 1;
    }

    // Set up command monitors
    startMonitors();
}

function updatePrefs()
{
    if(window.widget) {
        var prefs41 = widget.preferenceForKey("johnstarmerMMprefs41");
        if (!prefs41) {
            var keyIndex = widget.preferenceForKey("johnstarmerMMkey31");
            var mouseIndex = widget.preferenceForKey("johnstarmerMMmouse31");
            var trackIndex = widget.preferenceForKey("johnstarmerMMtrack31");
            
            if (keyIndex && keyIndex == 3) { widget.setPreferenceForKey(6,"johnstarmerMMkey31"); }
            if (mouseIndex && mouseIndex == 3) { widget.setPreferenceForKey(6,"johnstarmerMMmouse31"); }
            if (trackIndex && trackIndex == 3) { widget.setPreferenceForKey(5,"johnstarmerMMtrack31"); }
            
            widget.setPreferenceForKey(1,"johnstarmerMMprefs41");
        }
    }
}

function clearPrefs()
{
    if(window.widget) {
        widget.setPreferenceForKey(null,"johnstarmerMMkey31");
        widget.setPreferenceForKey(null,"johnstarmerMMmouse31");
        widget.setPreferenceForKey(null,"johnstarmerMMtrack31");
        widget.setPreferenceForKey(null,"johnstarmerMMdisplay31");
        widget.setPreferenceForKey(null,"johnstarmerMMwslider31");
        widget.setPreferenceForKey(null,"johnstarmerMMcslider31");
        widget.setPreferenceForKey(null,"johnstarmerMMmouseText31");
        widget.setPreferenceForKey(null,"johnstarmerMMkeyText31");
        widget.setPreferenceForKey(null,"johnstarmerMMtrackText31");
    }
}

//
// Function: remove()
// Called when the widget has been removed from the Dashboard
//
function remove()
{
    // Stop any timers to prevent CPU usage
    // Remove any preferences as needed
    // widget.setPreferenceForKey(null, dashcode.createInstancePreferenceKey("your-key"));
    if(window.widget) {
        //clearPrefs();
        widget.setPreferenceForKey(null,"johnstarmerMMupdate31");
    }
}

//
// Function: hide()
// Called when the widget has been hidden
//
function hide()
{
    // Stop monitor timers to prevent CPU usage
    if (monitorsRunning) {
        stopMonitors();
    }
}

//
// Function: show()
// Called when the widget has been shown
//
function show()
{
    // Restart any timers that were stopped on hide
    if (monitorsRunning === false) {
        startMonitors();
    }
    // get last update that was alerted
    updateShown = widget.preferenceForKey("johnstarmerMMupdate31");
    updateAvailable = 0;
    setTimeout("getLatestVersion()",3000);
}

function highlightLink()
{
    var update = document.getElementById("version");
    var updateText = document.getElementById("label-update");
        
    if (update.style.fontWeight == "bold") {
        if (update.style.textDecoration == "underline") {
            update.style.textDecoration = "none";
        } else {
            update.style.textDecoration = "underline";
        }
        if (updateText.style.textDecoration == "underline") {
            updateText.style.textDecoration = "none";
        } else {
            updateText.style.textDecoration = "underline";
        }
    }
}

function getLatestVersion()
{
    req = new XMLHttpRequest();
    var url = "http://www.starmerville.com/mm/versionlink.txt";
    req.onreadystatechange = processLatest;
    req.open("GET",url,false);
    req.send();
}

function launchDonate()
{    
    widget.openURL("http://www.starmerville.com/mm/mightymonitor/Donate.html");
}

function launchWebsite()
{
    var update = document.getElementById("version");
    
    if (update.style.fontWeight == "bold") {
        widget.openURL(updateURL);
    }
}

function processLatest()
{
    updateAvailable = 0;
    // only if req shows "loaded"
    if (req.readyState == 4) {
        if (req.status == 200) {
            var latestVersion = req.responseText;
            //updateAvailable = 0;
            //alert("latest="+latestVersion);
            try {
                var bpos = latestVersion.search("//");
                if (bpos && currentVersion != undefined) { // release version
                    //alert("latest version = " + latestVersion);
                    //alert("current version = " + currentVersion);
                    if (parseFloat(latestVersion.substr(0,bpos)) > parseFloat(currentVersion)) {
                        //alert("new version available!");
                        updateURL = "http://" + latestVersion.substr(bpos);
                        updateAvailable = 1;
                    } else {
                        //alert("already have latest version");
                    }
                }
                if (updateAvailable) {
                    var update = document.getElementById("version");
                    update.style.color = "#c90";
                    update.style.fontWeight = "bold";
                    update.innerText = currentVersion + " !";
                    widget.setPreferenceForKey(latestVersion,"johnstarmerMMupdate31");
                    if (latestVersion != updateShown) {
                        showUpdateAlert();
                        setTimeout("hideUpdateAlert()",3000);
                    } else {
                        updateAvailable=0;
                    }
                }
            }
            catch(e) {
                // getCurrentVersion failed, do nothing.
            }
        } 
    }
}

function getCurrentVersion()
{
    plistReq = new XMLHttpRequest();
    plistReq.onreadystatechange = processCurrent;
    plistReq.open("GET", "Info.plist", false);
    plistReq.send();
}

function processCurrent()
{
    // only if req shows "loaded"
    if (plistReq.readyState == 4) {
        var plist = plistReq.responseXML;
        var keys = plist.getElementsByTagName("key");

        for(var i=0; i<keys.length; i++){
            if("CFBundleVersion" == keys[i].firstChild.data) {
                currentVersion = keys[i].nextSibling.nextSibling.firstChild.data;
                //alert("current="+currentVersion);
                setElementText("version",currentVersion);
                drawCanvas("updateCanvas",17,4,44,206,90,true,"#dddddd","#b86600");
                break;
            }
        }
    }
}

function showUpdateAlert()
{
    if (updateAvailable) {
        var updateAlert = document.getElementById("update");

        clearInterval(fadeTimer);

        //drawCanvas("updateCanvas",17,4,44,206,true);
        updateAlert.style.display="block";
        fadeTimer = setInterval(function() {fade(updateAlert,0.02,0.02,0.98); },0.35);
    }
}

function hideUpdateAlert()
{
    if (updateAvailable) {
        var updateAlert = document.getElementById("update");

        clearInterval(fadeTimer);

        fadeTimer = setInterval(function() {fade(updateAlert,0.98,-0.02,0.02); },0.35);
    }
}

function fade(element,initial,increment,stop)
{
    var opacity = element.style.opacity;
        
    //if (opacity>stop) {opacity=stop;}
    
    if (!opacity) {
        element.style.opacity = initial;
    } else {
        element.style.opacity = parseFloat(opacity)+increment;
    }
    
    // stop callback
    if (initial>0.9) {
        if (element.style.opacity<stop) {
            clearInterval(fadeTimer);
            element.style.display="none";
        }
    } else {
        if (element.style.opacity>stop) {
            clearInterval(fadeTimer);
        }
    }
}

//
// Function: sync()
// Called when the widget has been synchronized with .Mac
//
function sync()
{
    // Retrieve any preference values that you need to be synchronized here
    // Use this for an instance key's value:
    // instancePreferenceValue = widget.preferenceForKey(null, dashcode.createInstancePreferenceKey("your-key"));
    //
    // Or this for global key's value:
    // globalPreferenceValue = widget.preferenceForKey(null, "your-key");
}

function drawCanvas(element,x,y,h,w,colorstop,shadow,topColor,bottomColor)
{
    var canvas = document.getElementById(element);
    var context = canvas.getContext("2d");
    var r = 12; // The roundness of the corners
    var gradient = context.createLinearGradient(0, 0, 0, colorstop);
    
    if (topColor == null) { topColor = "#ffffff"; }
    if (bottomColor == null) { bottomColor = "#787878"; }

    context.clearRect(0,0,canvas.width,canvas.height);
    gradient.addColorStop(0, topColor);
    gradient.addColorStop(1, bottomColor);
 
    context.fillStyle = '#dddddd';
    context.strokeStyle = '#a0a0a0';
    context.lineWidth = 2;


    if (shadow) {
        context.beginPath();
        context.moveTo(x+r, y);
        context.lineTo(x+w-r, y);
        context.quadraticCurveTo(x+w, y, x+w, y+r);
        context.lineTo(x+w, y+h-r);
        context.quadraticCurveTo(x+w, y+h, x+w-r, y+h);
        context.lineTo(x+r, y+h);
        context.quadraticCurveTo(x, y+h, x, y+h-r);
        context.lineTo(x, y+r);
        context.quadraticCurveTo(x, y, x+r, y);
        context.closePath();
        context.shadowOffsetX = -2;
        context.shadowOffsetY = 5;
        context.shadowBlur = 20;
        context.shadowColor = "rgba(0, 0, 0, 0.5)";
        context.fill();
    }
    
    context.beginPath();
    context.moveTo(x+r, y);
    context.lineTo(x+w-r, y);
    context.quadraticCurveTo(x+w, y, x+w, y+r);
    context.lineTo(x+w, y+h-r);
    context.quadraticCurveTo(x+w, y+h, x+w-r, y+h);
    context.lineTo(x+r, y+h);
    context.quadraticCurveTo(x, y+h, x, y+h-r);
    context.lineTo(x, y+r);
    context.quadraticCurveTo(x, y, x+r, y);
    context.closePath(); 
    context.shadowOffsetX = -2;
    context.shadowOffsetY = 5;
    context.shadowBlur = 20;
    context.shadowColor = "rgba(0, 0, 0, 0.5)";
    context.fillStyle = gradient;
    context.fill();

    context.shadowOffsetX = 0;
    context.shadowOffsetY = 0;
    context.shadowBlur = 0;
    context.shadowColor = "rgba(0, 0, 0, 0.0)";
    context.beginPath();
    context.moveTo(x+r, y);
    context.lineTo(x+w-r, y);
    context.quadraticCurveTo(x+w, y, x+w, y+r);
    context.lineTo(x+w, y+h-r);
    context.quadraticCurveTo(x+w, y+h, x+w-r, y+h);
    context.lineTo(x+r, y+h);
    context.quadraticCurveTo(x, y+h, x, y+h-r);
    context.lineTo(x, y+r);
    context.quadraticCurveTo(x, y, x+r, y);
    context.closePath();
    context.stroke();
}

// Update and resize the display depending on the preferences set (keyboard only, mouse only, or both)
function updateDisplay()
{
	var my_key = 1;
    var my_mouse = 1;
    var my_track = 1;
    var display_gauge = 1;
    //preferences
    var keyIndex = widget.preferenceForKey("johnstarmerMMkey31");
    var mouseIndex = widget.preferenceForKey("johnstarmerMMmouse31");
    var trackIndex = widget.preferenceForKey("johnstarmerMMtrack31");
    var displayIndex = widget.preferenceForKey("johnstarmerMMdisplay31");
    var warningValue = widget.preferenceForKey("johnstarmerMMwslider31");
    var criticalValue = widget.preferenceForKey("johnstarmerMMcslider31");
    var mouseText = widget.preferenceForKey("johnstarmerMMmouseText31");
    var keyText = widget.preferenceForKey("johnstarmerMMkeyText31");
    var trackText = widget.preferenceForKey("johnstarmerMMtrackText31");
    	
    //widget elements
    var keyboard = document.getElementById("gauge-keyboard");
	var mouse = document.getElementById("gauge-mouse");
	var trackpad = document.getElementById("gauge-trackpad");
	var bkeyboard = document.getElementById("indicator-keyboard");
	var bmouse = document.getElementById("indicator-mouse");
	var btrackpad = document.getElementById("indicator-trackpad");
	var bkeyback = document.getElementById("battery-background-keyboard");
	var bmouseback = document.getElementById("battery-background-mouse");
	var btrackback = document.getElementById("battery-background-trackpad");
	var bkeyP = document.getElementById("indicator-keyboardPercent");
	var bmouseP = document.getElementById("indicator-mousePercent");
	var btrackP = document.getElementById("indicator-trackpadPercent");
	var mouseLabel = document.getElementById("label-mouse");
	var keyLabel = document.getElementById("label-keyboard");
	var trackpadLabel = document.getElementById("label-trackpad");
    var widgetLabel = document.getElementById("label-widget");
	var backImg = document.getElementById("backImg");
    var mousePop = document.getElementById("mousepop");
    var keyPop = document.getElementById("keypop");
    var trackPop = document.getElementById("trackpop");
    var displayPop = document.getElementById("displaypop");
    var info = document.getElementById("info");
    var updateAlert = document.getElementById("update");
        
    if (mouseText === undefined) { mouseText = dashcode.getLocalizedString("Mouse"); }
    if (keyText === undefined) { keyText = dashcode.getLocalizedString("Keyboard"); }
    if (trackText === undefined) { trackText = dashcode.getLocalizedString("Trackpad"); }
    setElementText("label-mouse",mouseText);
    setElementText("label-keyboard",keyText);
    setElementText("label-trackpad",trackText);
    
    if (warningValue === undefined) { warningValue=25; }
    if (criticalValue === undefined) { criticalValue=10; }
    keyboard.object.setWarningValue(warningValue);
    keyboard.object.setCriticalValue(criticalValue);
    bkeyboard.object.setWarningValue(warningValue);
    bkeyboard.object.setCriticalValue(criticalValue);
    mouse.object.setWarningValue(warningValue);
    mouse.object.setCriticalValue(criticalValue);
    bmouse.object.setWarningValue(warningValue);
    bmouse.object.setCriticalValue(criticalValue);
    trackpad.object.setWarningValue(warningValue);
    trackpad.object.setCriticalValue(criticalValue);
    btrackpad.object.setWarningValue(warningValue);
    btrackpad.object.setCriticalValue(criticalValue);
       
    //Position Variables
    //1 Monitor
    var middleG = "92px";
    var middleB = "102px";
    var middleL = "70px";
    var info1 = "158px";
    
    //2 monitors
    var leftG2 = "60px";
    var rightG2 = "124px";
    var leftB2 = "70px";
    var rightB2 = "134px";
    var leftL2 = "38px";
    var rightL2 = "102px"
    var info2 = "178px"
    
    //3 monitors
    var leftG3 = "30px";
    var rightG3 = "154px";
    var leftB3 = "40px";
    var rightB3 = "164px";
    var leftL3 = "8px";
    var rightL3 = "132px";
    var info3 = "208px";
    
    //Height
    var topG = "88px";
    var topB = "102px";
    
    clearDisplay();
    
    if (mouseIndex === undefined) { mouseIndex = 2; }
    if (keyIndex === undefined) { keyIndex = 2; }
    if (trackIndex === undefined) { trackIndex = trackPop.options.length-1; }
    if (displayIndex === undefined) { displayIndex = 0; }
    
    //MOUSE
    mousePop.selectedIndex = mouseIndex;
    mouseString = mousePop.value.substring(5);
    mouseBattClass = parseInt(mousePop.value.substring(4,5));
    mouseClass = parseInt(mousePop.value.substring(0,4));
    if (mouseString == "None") { my_mouse = 0; }
        
    //TRACKPAD
    trackPop.selectedIndex = trackIndex;
    trackpadString = trackPop.value.substring(5);
    trackpadBattClass = parseInt(trackPop.value.substring(4,5));
    trackpadClass = parseInt(trackPop.value.substring(0,4));
    if (trackpadString == "None") { my_track = 0; }
    
    //KEYBOARD
    keyPop.selectedIndex = keyIndex;
    keyboardString = keyPop.value.substring(5);
    keyboardBattClass = parseInt(keyPop.value.substring(4,5));
    keyboardClass = parseInt(keyPop.value.substring(0,4));
    if (keyboardString == "None") { my_key = 0; }

    //DISPLAY
    displayPop.selectedIndex = displayIndex;
    if (displayPop.value == "Gauge") { display_gauge = 1; } else { display_gauge = 0; }

    //alert(MightyMonitor.getDeviceData(keyboardString,keyboardClass,1));

	//my_key = 1;
    //my_mouse = 1;
    //my_track = 1;
    //display_gauge = 0;

    //Defaults
    //Widget    
    info.style.left=info1;
    info.style.top=topG;
    updateAlert.style.display="none";
    
    //keyboard
    keyLabel.style.display="none";
    keyboard.style.display="none";
    bkeyboard.style.display="none";
    bkeyback.style.display="none";
    bkeyP.style.display="none";
    keyLabel.style.top=topG;
    keyLabel.style.left=middleL;
    keyboard.style.left=middleG;
    bkeyboard.style.left=middleB;
    bkeyback.style.left=middleB;
    bkeyP.style.left=middleB;
    
    //mouse
    mouseLabel.style.display="none";
    mouse.style.display="none";
    bmouse.style.display="none";
    bmouseback.style.display="none";
    bmouseP.style.display="none";
    mouseLabel.style.top=topG;
    mouse.style.left=middleG;
    mouseLabel.style.left=middleL;
    bmouse.style.left=middleB;
    bmouseback.style.left=middleB;
    bmouseP.style.left=middleB;
    
    //trackpad
    trackpadLabel.style.display="none";
    trackpad.style.display="none";
    btrackpad.style.display="none";
    btrackback.style.display="none";
    btrackP.style.display="none";
    trackpadLabel.style.top=topG;
    trackpad.style.left=middleG;
    trackpadLabel.style.left=middleL;
    btrackpad.style.left=middleB;
    btrackback.style.left=middleB;
    btrackP.style.left=middleB;


	if (!my_key && my_mouse && !my_track) { // mouse only
        info.style.left=info1;
        if (display_gauge) {
            drawCanvas("canvas",63,13,94,114,170,true);
            mouseLabel.style.display="block";
            mouse.style.display="block";
        } else {
            drawCanvas("canvas",63,13,108,114,170,true);
            info.style.top=topB;
            mouseLabel.style.top=topB;
            mouseLabel.style.display="block";
            bmouse.style.display="block";
            bmouseback.style.display="block";
        }
	} else if (!my_key && !my_mouse && my_track) { // trackpad only
        info.style.left=info1;
        if (display_gauge) {
            drawCanvas("canvas",63,13,94,114,170,true);
            trackpadLabel.style.display="block";
            trackpad.style.display="block";
        } else {
            drawCanvas("canvas",63,13,108,114,170,true);
            info.style.top=topB;
            trackpadLabel.style.top=topB;
            trackpadLabel.style.display="block";
            btrackpad.style.display="block";
            btrackback.style.display="block";
        }
	} else if (my_key && !my_mouse && !my_track) { // keyboard only
        info.style.left=info1;
        if (display_gauge) {
            drawCanvas("canvas",63,13,94,114,170,true);
            keyLabel.style.display="block";
            keyboard.style.display="block";
        } else {
            drawCanvas("canvas",63,13,108,114,170,true);
            info.style.top=topB;
            keyLabel.style.top=topB;
            keyLabel.style.display="block";
            bkeyboard.style.display="block";
            bkeyback.style.display="block";
        }
	} else if (my_key && my_mouse && !my_track) { // keyboard + mouse
        info.style.left=info2;
        if (display_gauge) {
            drawCanvas("canvas",44,13,95,152,170,true);
            keyLabel.style.left=leftL2;
            keyboard.style.left=leftG2;
            mouse.style.left=rightG2;
            mouseLabel.style.left=rightL2;
            mouseLabel.style.display="block";
            mouse.style.display="block";
            keyLabel.style.display="block";
            keyboard.style.display="block";
        } else {
            drawCanvas("canvas",44,13,109,152,170,true);
            info.style.top=topB;
            bkeyboard.style.left=leftB2;
            bkeyback.style.left=leftB2;
            bkeyP.style.left=leftB2;
            keyLabel.style.top=topB;
            keyLabel.style.left=leftL2;
            bmouse.style.left=rightB2;
            bmouseback.style.left=rightB2;
            bmouseP.style.left=rightB2;
            mouseLabel.style.top=topB;
            mouseLabel.style.left=rightL2;
            mouseLabel.style.display="block";
            keyLabel.style.display="block";
            bmouse.style.display="block";
            bmouseback.style.display="block";
            bkeyboard.style.display="block";
            bkeyback.style.display="block";
        }
	} else if (my_key && !my_mouse && my_track) { // keyboard + trackpad
        info.style.left=info2;
        if (display_gauge) {
            drawCanvas("canvas",44,13,95,152,170,true);
            trackpadLabel.style.left=rightL2;
            trackpad.style.left=rightG2;
            keyboard.style.left=leftG2;
            keyLabel.style.left=leftL2;
            keyLabel.style.display="block";
            keyboard.style.display="block";
            trackpadLabel.style.display="block";
            trackpad.style.display="block";
        } else {
            drawCanvas("canvas",44,13,109,152,170,true);
            info.style.top=topB;
            bkeyboard.style.left=leftB2;
            bkeyback.style.left=leftB2;
            bkeyP.style.left=leftB2;
            keyLabel.style.top=topB;
            keyLabel.style.left=leftL2;
            btrackpad.style.left=rightB2;
            btrackback.style.left=rightB2;
            btrackP.style.left=rightB2;
            trackpadLabel.style.top=topB;
            trackpadLabel.style.left=rightL2;
            trackpadLabel.style.display="block";
            keyLabel.style.display="block";
            btrackpad.style.display="block";
            btrackback.style.display="block";
            bkeyboard.style.display="block";
            bkeyback.style.display="block";
        }
	} else if (!my_key && my_mouse && my_track) { // mouse + trackpad
        info.style.left=info2;
        if (display_gauge) {
            drawCanvas("canvas",44,13,95,152,170,true);
            trackpadLabel.style.left=leftL2;
            trackpad.style.left=leftG2;
            mouse.style.left=rightG2;
            mouseLabel.style.left=rightL2;
            mouseLabel.style.display="block";
            mouse.style.display="block";
            trackpadLabel.style.display="block";
            trackpad.style.display="block";
        } else {
            drawCanvas("canvas",44,13,109,152,170,true);
            info.style.top=topB;
            btrackpad.style.left=leftB2;
            btrackback.style.left=leftB2;
            btrackP.style.left=leftB2;
            trackpadLabel.style.top=topB;
            trackpadLabel.style.left=leftL2;
            bmouse.style.left=rightB2;
            bmouseback.style.left=rightB2;
            bmouseP.style.left=rightB2;
            mouseLabel.style.top=topB;
            mouseLabel.style.left=rightL2;
            mouseLabel.style.display="block";
            trackpadLabel.style.display="block";
            bmouse.style.display="block";
            bmouseback.style.display="block";
            btrackpad.style.display="block";
            btrackback.style.display="block";
        }
	} else { //show all three
        info.style.left=info3;
        if (display_gauge) {
            drawCanvas("canvas",13,13,95,213,170,true);
            trackpadLabel.style.left=middleL;
            trackpad.style.left=middleG;
            keyboard.style.left=leftG3;
            keyLabel.style.left=leftL3;
            mouse.style.left=rightG3;
            mouseLabel.style.left=rightL3;
            mouseLabel.style.display="block";
            mouse.style.display="block";
            trackpadLabel.style.display="block";
            trackpad.style.display="block";
            keyLabel.style.display="block";
            keyboard.style.display="block";
        } else {
            drawCanvas("canvas",13,13,109,213,170,true);
            info.style.top=topB;
            bkeyboard.style.left=leftB3;
            bkeyback.style.left=leftB3;
            bkeyP.style.left=leftB3;
            keyLabel.style.top=topB;
            keyLabel.style.left=leftL3;
            btrackpad.style.left=middleB;
            btrackback.style.left=middleB;
            btrackP.style.left=middleB;
            trackpadLabel.style.top=topB;
            trackpadLabel.style.left=middleL;
            bmouse.style.left=rightB3;
            bmouseback.style.left=rightB3;
            bmouseP.style.left=rightB3;
            mouseLabel.style.top=topB;
            mouseLabel.style.left=rightL3;
            mouseLabel.style.display="block";
            trackpadLabel.style.display="block";
            bmouse.style.display="block";
            bmouseback.style.display="block";
            btrackpad.style.display="block";
            btrackback.style.display="block";
            keyLabel.style.display="block";
            bkeyboard.style.display="block";
            bkeyback.style.display="block";
        }
    }	
}

function changeStackView(event)
{
    // Get the current view element in a StackLayout
    var stackLayout = document.getElementById('stackLayout').object;
    var allViews = stackLayout.getAllViews();
    var currentView = stackLayout.getCurrentView();
    var currentIndex = -1;
    var moveRight = 0;

    // set moveRight
    if (event.clientX > 120) {
        moveRight=1;
    }
    
    // Get current index
    for (var i in allViews) {
        if (currentView==allViews[i]) {currentIndex = parseInt(i)+1;}
    }

    // Switch view
    if (currentIndex) {
        switch (currentIndex) {
            case 1:
                stackLayout.setCurrentView('view2',moveRight);
                break;
            case 2:
                stackLayout.setCurrentView('view1',moveRight);
        }
    }

}

//
// Function: showBack(event)
// Called when the info button is clicked to show the back of the widget
//
// event: onClick event from the info button
//
function showBack(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToBack");
    }

    hide();
    initSliders();
    initLabelPrefs();
    
    front.style.display="none";
    back.style.display="block";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

function savePrefs()
{
    if(window.widget) {
        var mousePop = document.getElementById("mousepop").selectedIndex;
        var keyPop = document.getElementById("keypop").selectedIndex;
        var trackPop = document.getElementById("trackpop").selectedIndex;
        var displayPop = document.getElementById("displaypop").selectedIndex;
        var wslider = document.getElementById("warning-slider");
        var cslider = document.getElementById("critical-slider");
        var mouseBox = document.getElementById("mouseText");
        var keyBox = document.getElementById("keyText");
        var trackBox = document.getElementById("trackText");
        
        //alert("|"+keyBox.value+"|"+trackBox.value+"|"+mouseBox.value+"|"+wslider.value+"|"+cslider.value);// save prefs
        //if (keyBox.value == "") { alert("null!!!"); }
        
        widget.setPreferenceForKey(keyPop,"johnstarmerMMkey31");
        widget.setPreferenceForKey(mousePop,"johnstarmerMMmouse31");
        widget.setPreferenceForKey(trackPop,"johnstarmerMMtrack31");
        widget.setPreferenceForKey(displayPop,"johnstarmerMMdisplay31");
        if (mouseBox.value != "") { widget.setPreferenceForKey(parseInt(wslider.value),"johnstarmerMMwslider31"); }
        if (mouseBox.value != "") { widget.setPreferenceForKey(parseInt(cslider.value),"johnstarmerMMcslider31"); }
        if (mouseBox.value != "") { widget.setPreferenceForKey(mouseBox.value,"johnstarmerMMmouseText31"); }
        if (keyBox.value != "") { widget.setPreferenceForKey(keyBox.value,"johnstarmerMMkeyText31"); }
        if (trackBox.value != "") { widget.setPreferenceForKey(trackBox.value,"johnstarmerMMtrackText31"); }
    }
}


//
// Function: showFront(event)
// Called when the done button is clicked from the back of the widget
//
// event: onClick event from the done button
//
function showFront(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    savePrefs();
    
    if (window.widget) {
        widget.prepareForTransition("ToFront");
    }

    front.style.display="block";
    back.style.display="none";
    updateDisplay();
    startMonitors();

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

if (window.widget)
{
    widget.onremove = remove;
    widget.onhide = hide;
    widget.onshow = show;
    widget.onsync = sync;
}
